Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.0.0.Beta5
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.optaplanner.core.impl.heuristic.selector.move.decorator
Class ProbabilityMoveSelector

    java.lang.Object
      org.optaplanner.core.impl.heuristic.selector.AbstractSelector
          org.optaplanner.core.impl.heuristic.selector.move.AbstractMoveSelector
              org.optaplanner.core.impl.heuristic.selector.move.decorator.ProbabilityMoveSelector

All Implemented Interfaces:
  Iterable<Move>, EventListener, SelectionCacheLifecycleListener, IterableSelector<Move>, MoveSelector, Selector, SolverPhaseLifecycleListener, SolverLifecycleListener

    public class ProbabilityMoveSelector

extends AbstractMoveSelector
implements SelectionCacheLifecycleListener

Field Summary
`protected NavigableMap<Double,Move>` | `cachedMoveMap`
`protected SelectionCacheType` | `cacheType`
`protected MoveSelector` | `childMoveSelector`
`protected SelectionProbabilityWeightFactory` | `probabilityWeightFactory`
`protected double` | `probabilityWeightTotal`

Fields inherited from class org.optaplanner.core.impl.heuristic.selector.AbstractSelector
`logger, solverPhaseLifecycleSupport, workingRandom`

Constructor Summary
`ProbabilityMoveSelector(MoveSelector childMoveSelector, SelectionCacheType cacheType, SelectionProbabilityWeightFactory probabilityWeightFactory)`

Method Summary
`void` | `constructCache(DefaultSolverScope solverScope)`
`void` | `disposeCache(DefaultSolverScope solverScope)`
`SelectionCacheType` | `getCacheType()` Unless this selector itself caches, this returns `SelectionCacheType.JUST_IN_TIME`, even if a selector child caches.
`long` | `getSize()` A random JIT `Selector` with `Selector.isNeverEnding()` true should return a size as if it would be able to return each distinct element only once, because the size can be used in `SelectionProbabilityWeightFactory`.
`boolean` | `isContinuous()` If true, then `Selector.isNeverEnding()` is also true.
`boolean` | `isNeverEnding()` Is true if `Selector.isContinuous()` is true or if this selector is in random order (for most cases).
`Iterator<Move>` | `iterator()`
`String` | `toString()`

Methods inherited from class org.optaplanner.core.impl.heuristic.selector.AbstractSelector
`phaseEnded, phaseStarted, solvingEnded, solvingStarted, stepEnded, stepStarted`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.optaplanner.core.impl.phase.event.SolverPhaseLifecycleListener
`phaseEnded, phaseStarted, stepEnded, stepStarted`

Methods inherited from interface org.optaplanner.core.impl.solver.event.SolverLifecycleListener
`solvingEnded, solvingStarted`

Field Detail

### childMoveSelector

    protected final MoveSelector childMoveSelector

### cacheType

    protected final SelectionCacheType cacheType

### probabilityWeightFactory

    protected final SelectionProbabilityWeightFactory probabilityWeightFactory

### cachedMoveMap

    protected NavigableMap<Double,Move> cachedMoveMap

### probabilityWeightTotal

    protected double probabilityWeightTotal

Constructor Detail

### ProbabilityMoveSelector

    public ProbabilityMoveSelector(MoveSelector childMoveSelector,
                                   SelectionCacheType cacheType,
                                   SelectionProbabilityWeightFactory probabilityWeightFactory)

Method Detail

### getCacheType

    public SelectionCacheType getCacheType()

  Description copied from interface: `Selector`
  Unless this selector itself caches, this returns `SelectionCacheType.JUST_IN_TIME`, even if a selector child caches.

  Specified by:
    `getCacheType` in interface `Selector`
  Overrides:
    `getCacheType` in class `AbstractSelector`
  Returns:
    never null

### constructCache

    public void constructCache(DefaultSolverScope solverScope)

  Specified by:
    `constructCache` in interface `SelectionCacheLifecycleListener`

### disposeCache

    public void disposeCache(DefaultSolverScope solverScope)

  Specified by:
    `disposeCache` in interface `SelectionCacheLifecycleListener`

### isContinuous

    public boolean isContinuous()

  Description copied from interface: `Selector`
  If true, then `Selector.isNeverEnding()` is also true.

  Specified by:
    `isContinuous` in interface `Selector`
  Returns:
    true if any of the value ranges are continuous (as in for example every double value between 1.2 and 1.4)

### isNeverEnding

    public boolean isNeverEnding()

  Description copied from interface: `Selector`
  Is true if `Selector.isContinuous()` is true or if this selector is in random order (for most cases). Is never true when this selector is in shuffled order (which is less scalable but more exact).

  Specified by:
    `isNeverEnding` in interface `Selector`
  Returns:
    true if the `Iterator.hasNext()` of the `Iterator` created by `Iterable.iterator()` never returns false.

### getSize

    public long getSize()

  Description copied from interface: `IterableSelector`
  A random JIT `Selector` with `Selector.isNeverEnding()` true should return a size as if it would be able to return each distinct element only once, because the size can be used in `SelectionProbabilityWeightFactory`.

  Specified by:
    `getSize` in interface `IterableSelector<Move>`
  Returns:
    the approximate number of elements generated by this `Selector`, always >= 0

### iterator

    public Iterator<Move> iterator()

  Specified by:
    `iterator` in interface `Iterable<Move>`

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.0.0.Beta5
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2013 JBoss by Red Hat. All Rights Reserved.